#pragma once

#include <cstdint>
#include <windows.h>
#include <winternl.h>
#include "../pluginsdk/_plugins.h"

// Plugin name and version
#define PLUGIN_NAME "InstrLogger"
#define PLUGIN_VERSION 1

// Settings INI filename
#define CUSTOM_INI_FILENAME "InstrLoggerSettings.ini"

// Menu IDs
#define MENU_START_LOGGING 1
#define MENU_STOP_LOGGING 2
#define MENU_CLEAR_LOG 3
#define MENU_SAVE_LOG 4
#define MENU_SETTINGS 5
#define MENU_HELP 6

// Settings dialog IDs
#define IDC_CALLS_CHECK 1001
#define IDC_JUMPS_CHECK 1002
#define IDC_RETURNS_CHECK 1003
#define IDC_MODULE_CHECK 1004
#define IDC_FOLLOW_CHECK 1005
#define IDC_FILE_CHECK 1006
#define IDC_FILE_PATH 1007
#define IDC_BROWSE_BTN 1008
#define IDC_OK_BTN 1009
#define IDC_CANCEL_BTN 1010

// Exported plugin functions
extern "C" __declspec(dllexport) bool pluginit(PLUG_INITSTRUCT* initStruct);
extern "C" __declspec(dllexport) void plugstop();
extern "C" __declspec(dllexport) void plugsetup(PLUG_SETUPSTRUCT* setupStruct);
extern "C" __declspec(dllexport) void CBBREAKPOINT(CBTYPE cbType, PLUG_CB_BREAKPOINT* info);
extern "C" __declspec(dllexport) void CBSTEPPED(CBTYPE cbType, PLUG_CB_STEPPED* info);
extern "C" __declspec(dllexport) void CBTRACEEXECUTE(CBTYPE cbType, PLUG_CB_TRACEEXECUTE* info);
extern "C" __declspec(dllexport) void CBMENUENTRY(CBTYPE cbType, PLUG_CB_MENUENTRY* info);
extern "C" __declspec(dllexport) void CBWINEVENT(CBTYPE cbType, PLUG_CB_WINEVENT* info);

// New functions
bool IsJumpInstruction(const unsigned char* data, size_t size);
bool IsCallInstruction(const unsigned char* data, size_t size);
bool IsRetInstruction(const unsigned char* data, size_t size);
